#include "queue.h"

#include "stdio.h"
#include "stdlib.h"
#include "string.h"

queue_t* q;

void add(int a){
  int* p = (int*) malloc(sizeof(int));
  *p = a;
  bool ret = push_to_queue(q, (void*)p);
  if(!ret){
    free(p);
  }
}

void print_and_free(void* p){
    if(p != NULL){
        printf("%d\n", *((int*)p));
        free(p);
    } else {
        printf("NULL\n");
    }
}

void pop(){
  print_and_free(pop_from_queue(q));
}

void get(int idx){
  print_and_free(get_from_queue(q, idx));
}

int main(){
  
  int n;
  scanf("%d", &n);
  q = create_queue(n);
  
  while(true){
    char s[2];
    int ret = scanf("%1s", s);
    if(ret != 1){
      break;
    }
    
    if(s[0] == 'a'){
      int a;
      ret = scanf("%d", &a);
      if(ret != 1){
	break;
      }
      add(a);
    } else if(s[0] == 'r'){
      pop();
    } else if(s[0] == 'g'){
      int a;
      ret = scanf("%d", &a);
      if(ret != 1){
	break;
      }
      get(a);
    }
  }
  
  while(get_queue_size(q)){
    void* p = pop_from_queue(q);
    free(p);
  }
  
  delete_queue(q);
  q = NULL;
   
  return(0);
}

